//************************************************************************
// Hiddll.h
//
// HID.DLL function definitions and prototyes declaration
// NOT all functions of HID.DLL are defined here !
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 31.12.2003
// Compiler Visual C++ V5.0
//************************************************************************


#ifndef _HIDDLL_H
#define _HIDLL_H

extern HINSTANCE hhid;


#include <pshpack4.h>

typedef PVOID HDEVINFO;

extern HDEVINFO PnPHandle;
extern int LoadHidDll();
extern void UnloadHidDll();
extern int FindHIDDevice(unsigned int vid, unsigned int pid);
extern void HIDCleanup();

typedef struct _HIDD_CONFIGURATION {
    PVOID    cookie;
    ULONG    size;
    ULONG    RingBufferSize;
} HIDD_CONFIGURATION, *PHIDD_CONFIGURATION;

typedef struct _HIDD_ATTRIBUTES {
    ULONG   Size; // = sizeof (struct _HIDD_ATTRIBUTES)

    //
    // Vendor ids of this hid device
    //
    USHORT  VendorID;
    USHORT  ProductID;
    USHORT  VersionNumber;

    //
    // Additional fields will be added to the end of this structure.
    //
} HIDD_ATTRIBUTES, *PHIDD_ATTRIBUTES;

typedef BOOLEAN (WINAPI* DLL_HidD_GetAttributes)(
    HANDLE              HidDeviceObject,
    PHIDD_ATTRIBUTES    Attributes
    );
extern DLL_HidD_GetAttributes HidD_GetAttributes;

typedef void (WINAPI* DLL_HidD_GetHidGuid)(LPGUID HidGuid);
extern DLL_HidD_GetHidGuid HidD_GetHidGuid;

typedef BOOLEAN (WINAPI* DLL_HidD_GetFeature)(
   HANDLE   HidDeviceObject,
   PVOID    ReportBuffer,
   ULONG    ReportBufferLength
   );
extern DLL_HidD_GetFeature HidD_GetFeature;
/*++
Routine Description:
   Retrieve a feature report from a HID device.
--*/

typedef BOOLEAN (WINAPI* DLL_HidD_SetFeature)(
   HANDLE   HidDeviceObject,
   PVOID    ReportBuffer,
   ULONG    ReportBufferLength
   );
extern DLL_HidD_SetFeature HidD_SetFeature;
/*++
Routine Description:
   Send a feature report to a HID device.
--*/

typedef BOOLEAN (WINAPI* DLL_HidD_GetNumInputBuffers)(
    HANDLE  HidDeviceObject,
    PULONG  NumberBuffers
    );
extern DLL_HidD_GetNumInputBuffers HidD_GetNumInputBuffers;

typedef BOOLEAN (WINAPI* DLL_HidD_SetNumInputBuffers)(
    HANDLE HidDeviceObject,
    ULONG  NumberBuffers
    );
extern DLL_HidD_SetNumInputBuffers HidD_SetNumInputBuffers;
/*++
Routine Description:
    Number of hid packets actually retained
--*/

typedef BOOLEAN (WINAPI* DLL_HidD_GetManufacturerString)(
   HANDLE   HidDeviceObject,
   PVOID    Buffer,
   ULONG    BufferLength
   );
extern DLL_HidD_GetManufacturerString HidD_GetManufacturerString;

typedef BOOLEAN (WINAPI* DLL_HidD_GetProductString)(
   HANDLE   HidDeviceObject,
   PVOID    Buffer,
   ULONG    BufferLength
   );
extern DLL_HidD_GetProductString HidD_GetProductString;


typedef BOOLEAN (WINAPI* DLL_HidD_GetSerialNumberString)(
   HANDLE   HidDeviceObject,
   PVOID    Buffer,
   ULONG    BufferLength
   );
extern DLL_HidD_GetSerialNumberString HidD_GetSerialNumberString;

typedef BOOLEAN (WINAPI* DLL_HidD_GetPhysicalDescriptor)(
   HANDLE   HidDeviceObject,
   PVOID    Buffer,
   ULONG    BufferLength
   );
extern DLL_HidD_GetPhysicalDescriptor HidD_GetPhysicalDescriptor;

typedef BOOLEAN (WINAPI* DLL_HidD_GetIndexedString)(
   HANDLE   HidDeviceObject,
   ULONG    StringIndex,
   PVOID    Buffer,
   ULONG    BufferLength
   );
extern DLL_HidD_GetIndexedString HidD_GetIndexedString;

#include <poppack.h>

#endif //_HIDDLL_H
